import { loginStatusPage, post } from '@/utils/https';
import {
  cloneLite,
  getAuthInfo,
  getDataSet,
  sleep,
  toastError,
  toastSuccess,
  toObject,
} from '@/utils/util';

const defaultParams = { comments: '', crm_name: '', crm_type: 1 };

Page({
  /**
   * 页面的初始数据
   */
  data: {
    params: cloneLite(defaultParams) as any,
    mode: 'new' as 'new' | 'edit',
  },
  handleLogin(e: any) {
    this.setData({ isLogin: e.detail });
    if (e.detail) {
      this.init();
    }
  },
  init() {
    this.setData({ authInfo: getAuthInfo() });
  },
  onChange(e: any) {
    const key = getDataSet(e).key;
    const val = e.detail.value;
    this.data.params[key] = val;
    this.setData({ params: this.data.params });
  },
  onCheckboxChange(e: any) {
    const key = getDataSet(e).key;
    this.data.params[key] = e.detail.checked ? 1 : 2;
    this.setData({ params: this.data.params });
  },
  onSave() {
    // console.log(this.data.params);
    if (this.data.params.crm_name) {
      if (this.data.params.crm_phone && this.data.params.crm_phone.length != 11) {
        toastError('手机号码需11位');
        return;
      }

      post(this.data.mode == 'new' ? 'ErpCrm/add' : 'ErpCrm/edit', this.data.params).then(() => {
        toastSuccess('保存成功');
        sleep(() => {
          wx.navigateBack();
        }, 1000);
      });
    } else {
      toastError('项目名称必填');
    }
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(_options) {
    const eventChannel: any = this.getOpenerEventChannel();
    eventChannel?.on('customerEdit', (e: any) => {
      const data = toObject(e.data);

      Object.keys(data).forEach((key) => {
        if (data[key] === null) {
          data[key] = '';
        }
      });

      // console.log(data);
      wx.setNavigationBarTitle({
        title: data.crm_id
          ? `${data.crm_name} 修改`
          : data.crm_type == 1
          ? '新增经销商'
          : '新增供应商',
      });
      this.setData({ params: data, mode: data.crm_id ? 'edit' : 'new' });
    });
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {},

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {
    loginStatusPage(this);
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {},

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {},

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {},

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {},

  /**
   * 用户点击右上角分享
   */
  // onShareAppMessage() {},
});
